unit unitprinc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, ExtCtrls, StdCtrls, ComCtrls,
  ExtDlgs, UnitCSize, DSMandel;

type
  TFormPrinc = class(TForm)
    MainMenu: TMainMenu;
    MenuFichiers: TMenuItem;
    MenuItemQuitter: TMenuItem;
    MenuItemResolution: TMenuItem;
    MenuItem320x240: TMenuItem;
    MenuItem640x480: TMenuItem;
    MenuItem800x600: TMenuItem;
    MenuItemRender: TMenuItem;
    MenuItem640x400: TMenuItem;
    MenuItem1024x768: TMenuItem;
    ScrollBox: TScrollBox;
    GroupBoxConfig: TGroupBox;
    EditXMin: TEdit;
    LabelXmax: TLabel;
    EditXMax: TEdit;
    EditYMin: TEdit;
    LabelYmin: TLabel;
    EditYMax: TEdit;
    LabelYmax: TLabel;
    LabelMaxIter: TLabel;
    EditMaxIter: TEdit;
    LabelXmin: TLabel;
    SavePictureDialog: TSavePictureDialog;
    StatusBar: TStatusBar;
    MenuItemEnregistrerSous: TMenuItem;
    N2: TMenuItem;
    MenuItemdefine: TMenuItem;
    Timer: TTimer;
    DSMandel1: TDSMandel;
    EnregisterlesparamtresSous1: TMenuItem;
    ChargerlesParamtres1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    procedure MenuItemQuitterClick(Sender: TObject);
    procedure MenuItem320x240Click(Sender: TObject);
    procedure MenuItem640x400Click(Sender: TObject);
    procedure MenuItem640x480Click(Sender: TObject);
    procedure MenuItem800x600Click(Sender: TObject);
    procedure MenuItem1024x768Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MenuItemRenderClick(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure MenuItemEnregistrerSousClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MenuItemdefineClick(Sender: TObject);
    procedure DoHint(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure DSMandel1Start(Sender: TObject);
    procedure DSMandel1Finish(Sender: TObject);
    procedure DSMandel1Reset(Sender: TObject);
    procedure DSMandel1Stop(Sender: TObject);
    procedure DSMandel1PercentChange(Sender: TObject);
    procedure EditXMinExit(Sender: TObject);
    procedure EditXMaxExit(Sender: TObject);
    procedure EditYMinExit(Sender: TObject);
    procedure EditYMaxExit(Sender: TObject);
    procedure EditMaxIterExit(Sender: TObject);
    procedure DSMandel1ChangeZoom(Sender: TObject);
    procedure EnregisterlesparamtresSous1Click(Sender: TObject);
    procedure ChargerlesParamtres1Click(Sender: TObject);
    procedure EditXMinKeyPress(Sender: TObject; var Key: Char);
    procedure EditMaxIterKeyPress(Sender: TObject; var Key: Char);
    procedure EditXMaxKeyPress(Sender: TObject; var Key: Char);
    procedure EditYMinKeyPress(Sender: TObject; var Key: Char);
    procedure EditYMaxKeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
    STBmp: TBitmap;
  public
    { Dclarations publiques }
    StartTime: TDateTime;
    AddedTime: TDateTime;
    ElapsedTime: TDateTime;
    procedure Setup;
  end;

var
  FormPrinc: TFormPrinc;
  BWidth: integer;
  BHeight: integer;
  BXMin: extended;
  BXMax: extended;
  BYMin: extended;
  BYMax: extended;
  BMaxIter: integer;
  percent: integer;

implementation

{$R *.DFM}

procedure TFormPrinc.MenuItemQuitterClick(Sender: TObject);
begin
  Close;
end;

procedure TFormPrinc.MenuItem320x240Click(Sender: TObject);
begin
  MenuItem320x240.Checked := True;
  BWidth := 320;
  BHeight := 240;
  Setup;
end;

procedure TFormPrinc.MenuItem640x400Click(Sender: TObject);
begin
  MenuItem640x400.Checked := True;
  BWidth := 640;
  BHeight := 400;
  Setup;
end;

procedure TFormPrinc.MenuItem640x480Click(Sender: TObject);
begin
  MenuItem640x480.Checked := True;
  BWidth := 640;
  BHeight := 480;
  Setup;
end;

procedure TFormPrinc.MenuItem800x600Click(Sender: TObject);
begin
  MenuItem800x600.Checked := True;
  BWidth := 800;
  BHeight := 600;
  Setup;
end;

procedure TFormPrinc.MenuItem1024x768Click(Sender: TObject);
begin
  MenuItem1024x768.Checked := True;
  BWidth := 1024;
  BHeight := 768;
  Setup;
end;

procedure TFormPrinc.FormCreate(Sender: TObject);
begin
  Stbmp := TBitmap.Create;
  BWidth := 320;
  BHeight := 240;
  Application.OnHint := DoHint;
  Setup;
end;

procedure TFormPrinc.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  StBmp.Free;
end;

procedure TFormPrinc.MenuItemRenderClick(Sender: TObject);
begin
  Setup;
end;

procedure TFormPrinc.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
  pCanvas: ^TCanvas;
  nbcs: integer;
  i: integer;
begin
  percent := DSMandel1.Percent;
  pCanvas := @Statusbar.Canvas;
  if DSMandel1.Mode = mbidle then
    begin
      pCanvas.Brush.Color := clBtnFace;
      pCanvas.FillRect(Rect);
      pCanvas.Font.Color := clBtnText;
      if Panel.Index = 0 then
        begin
          pCanvas.TextOut(Rect.left + 10,Rect.Top,'Travail');
        end;
    end
  else
    begin
      if panel.index = 1 then
        pCanvas.Draw(Rect.Left,rect.top,StBmp);
      pCanvas.Font.Color := clBtnText;
      if panel.Index = 0 then
        begin
          pCanvas.Brush.Color := clBtnFace;
          pCanvas.FillRect(Rect);
          pCanvas.TextOut(Rect.left,Rect.Top,'Rendering');
        end;
      if panel.Index = 1 then
        begin
          StBmp.Width := Rect.Right - Rect.Left;
          StBmp.Height := Rect.Bottom - Rect.Top;
          StBmp.Canvas.Brush.Color := clBtnFace;
          StBmp.Canvas.FillRect(Classes.Rect(0,0,StBmp.Width,StBmp.Height));
          nbcs := round(((Rect.Right - Rect.Left) * (percent) / 100) / 8);
          stBmp.Canvas.Brush.Color := clHighLight;
          for i := 0 to nbcs do
            begin
              stBmp.Canvas.FillRect(Classes.Rect(i*8,0,i*8+6,Rect.bottom-Rect.top));
            end;
          StBmp.Canvas.Brush.Color := clBtnFace;
          StBmp.Canvas.TextOut((Rect.Right - Rect.left) div 2,0,IntToStr(Percent) + ' %');
          pCanvas.Draw(Rect.Left,rect.top,StBmp);
        end;
    end;
end;

procedure TFormPrinc.MenuItemEnregistrerSousClick(Sender: TObject);
begin
  If SavePictureDialog.Execute then
    begin
      DSMAndel1.SaveBitmapToFile(SavePictureDialog.FileName);
    end;
end;

procedure TFormPrinc.Setup;
begin
  Caption := 'MandelBrot Generator - ' + IntToStr(BWidth) + 'x' + IntToStr(Bheight);
  if DSMAndel1.Width <> BWidth then DSMandel1.Width := BWidth;
  if DSMAndel1.Height <> BWidth then DSMandel1.Height := BHeight;
  DSMandel1.Start;
end;

procedure TFormPrinc.FormResize(Sender: TObject);
begin
  StatusBar.Panels.Items[1].Width := StatusBar.Width - 130;
end;

procedure TFormPrinc.MenuItemdefineClick(Sender: TObject);
var
  oldw,oldh: integer;
begin
  oldw := BWidth;
  oldh := BHeight;
  FormCustomSize := TFormCustomSize.Create(self);
  if (FormCustomSize.ShowModal = mrOk) and ((oldw <> BWidth) or (oldh <>BHeight)) then
    begin
      Setup;
    end;
  FormCustomSize.Free;
end;

procedure TFormPrinc.DoHint(Sender: TObject);
begin
  StatusBar.Panels.Items[1].Text := Application.Hint;
end;

procedure TFormPrinc.TimerTimer(Sender: TObject);
begin
  if DSMandel1.Mode = mbRendering then
    begin
      ElapsedTime := now - StartTime;
      StatusBar.Panels.Items[2].Text := TimeToStr(ElapsedTime + AddedTime);
    end;
end;

procedure TFormPrinc.DSMandel1Start(Sender: TObject);
begin
  if Assigned(StatusBar) and Assigned(Stbmp) then
  StatusBar.Panels.Items[1].Style := psOwnerDraw;
  StartTime := now;
end;

procedure TFormPrinc.DSMandel1Finish(Sender: TObject);
begin
  ElapsedTime := AddedTime + ElapsedTime;
  AddedTime := 0;
end;

procedure TFormPrinc.DSMandel1Reset(Sender: TObject);
begin
  AddedTime := 0;
end;

procedure TFormPrinc.DSMandel1Stop(Sender: TObject);
begin
  if Assigned(StatusBar) and Assigned(Stbmp) then
  StatusBar.Panels.Items[1].Style := psText;
  AddedTime := AddedTime + ElapsedTime;
end;

procedure TFormPrinc.DSMandel1PercentChange(Sender: TObject);
begin
  if Assigned(StatusBar) and Assigned(Stbmp) then
  StatusBar.Refresh;
end;

procedure TFormPrinc.EditXMinExit(Sender: TObject);
begin
  if DSMandel1.XMin <> StrToFloat(EditXMin.Text) then
    begin
      DSMandel1.XMin := StrToFloat(EditXMin.Text);
      DSMandel1.Start;
    end;
end;

procedure TFormPrinc.EditXMaxExit(Sender: TObject);
begin
  if DSMandel1.XMax <> StrToFloat(EditXMax.Text) then
    begin
      DSMandel1.XMax := StrToFloat(EditXMax.Text);
      DSMandel1.Start;
    end;
end;

procedure TFormPrinc.EditYMinExit(Sender: TObject);
begin
  if DSMandel1.YMin <> StrToFloat(EditYMin.Text) then
    begin
      DSMandel1.YMin := StrToFloat(EditYMin.Text);
      DSMandel1.Start;
    end;
end;

procedure TFormPrinc.EditYMaxExit(Sender: TObject);
begin
  if DSMandel1.YMax <> StrToFloat(EditYMax.Text) then
    begin
      DSMandel1.YMax := StrToFloat(EditYMax.Text);
      DSMandel1.Start;
    end;
end;

procedure TFormPrinc.EditMaxIterExit(Sender: TObject);
begin
  if DSMandel1.MaxIter <> StrToInt(EditMaxIter.Text) then
    begin
      DSMandel1.MaxIter := StrToInt(EditMAxIter.Text);
      DSMandel1.Start;
    end;
end;

procedure TFormPrinc.DSMandel1ChangeZoom(Sender: TObject);
begin
  EditXMin.Text := FloatToStr(DSMandel1.XMin);
  EditXMax.Text := FloatToStr(DSMandel1.XMax);
  EditYMin.Text := FloatToStr(DSMandel1.YMin);
  EditYMax.Text := FloatToStr(DSMandel1.YMax);
  EditMaxIter.Text := IntToStr(DSMandel1.MaxIter);
end;

procedure TFormPrinc.EnregisterlesparamtresSous1Click(Sender: TObject);
begin
  if SaveDialog.Execute then
    begin
      DSMandel1.SaveParamsToFile(SaveDialog.FileName);
    end;
end;

procedure TFormPrinc.ChargerlesParamtres1Click(Sender: TObject);
begin
  if OpenDialog.Execute then
    begin
      DSMandel1.ReadParamsFromFile(OpenDialog.FileName);
      DSMandel1.Start;
    end;
end;

procedure TFormPrinc.EditXMinKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    begin
      key := #0;
      EditXMinExit(Sender);
    end;
end;

procedure TFormPrinc.EditMaxIterKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    begin
      key := #0;
      EditMaxIterExit(Sender);
    end;
end;

procedure TFormPrinc.EditXMaxKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    begin
      key := #0;
      EditXMaxExit(Sender);
    end;
end;

procedure TFormPrinc.EditYMinKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    begin
      key := #0;
      EditYMinExit(Sender);
    end;
end;

procedure TFormPrinc.EditYMaxKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    begin
      key := #0;
      EditYMaxExit(Sender);
    end;
end;

end.
